function Nm = LagkJointMomentsFromRAP (D0, D1, lag)

if nargin<3
    lag = 1;
end

maxk=size(D0,1);

Nm = zeros (maxk);
moms = zeros (1, 2*maxk-1);

mf = size(D0,1);
P = inv(-D0)*D1;
M = P - eye(mf);
M = [ones(mf,1) M(:,2:mf)];
piv = [1 zeros(1,mf-1)] * inv(M);



for i=0:maxk-1
    for j=0:maxk-1
        Nm(i+1,j+1) = sum (piv * factorial(i) * inv(-D0)^i * P^lag * factorial(j) * inv(-D0)^j);
    end
end
