function [B,n]=staircase(X,Y,Z)
%Computes a smaller representation of RAP using staircase algorithm

%D0=X;
%D1=Y;

m=size(X,1);

U=eye(size(X));

%The sum of the ranks calculated in every loop
ranksum=0;

crit=1; %The stopping criteria

while crit
    r=rank(Z);
    ranksum=ranksum+r;
    [Ui,S,T] = svd(Z);
    
    %Computation of Z_1,X_i,Y_i
    TEMP=Ui'*Z;
    Z1=TEMP(1:r,:);
    
    TEMP=Ui'*X*Ui;
    X1=TEMP(1:r,1:r);
    X2=TEMP(1:r,r+1:end);
    X3=TEMP(r+1:end,1:r);
    X4=TEMP(r+1:end,r+1:end);
    
   
    TEMP=Ui'*Y*Ui;
    Y1=TEMP(1:r,1:r);
    Y2=TEMP(1:r,r+1:end);
    Y3=TEMP(r+1:end,1:r);
    Y4=TEMP(r+1:end,r+1:end);
    
    %Calculation of the new U,X,Z matrices
    Transf=eye(ranksum-r+size(Ui,1));
    Transf(end-size(Ui,1)+1:end,end-size(Ui,2)+1:end)=Ui';
    U=(Transf*U')';
     
    X=X4;
    Y=Y4;
    Z=[X3,Y3];
    
    %norm(Z)
    %m-ranksum-rank(Z)
      
    if norm(Z)<1e-8 || rank(Z)==m-ranksum
        crit=0;
    end
end

n=ranksum;

%U'*D0*U
%U'*D1*U
%norm(Z)


I=eye(m,m);
if norm(Z)<1e-8
    n=ranksum;
    x=U'*ones(size(U,1),1);
    x=x(1:n);
    
    %does x have a 0 value somewhere
    yes=0;
    zeroloc=zeros(n,1);
    nonzero=0; %this will indicate a row of x for which x's value is non-zero
    for l=1:n
       if abs(x(l))<10^(-8)
           yes=1;
           zeroloc(l,1)=1;
       elseif nonzero==0
           nonzero=l;
       end
    end
    
    R=eye(n,n);
    if yes
        for l=1:n;
           if zeroloc(l,1)==1;
            R(l,nonzero)=1;
	end
        end
    end

    y=R*x;
    Gamma=diag(y);
    TEMP1=I; TEMP1(1:n,1:n)=Gamma\eye(size(Gamma));
    TEMP2=I; TEMP2(1:n,1:n)=R;
    
    B=inv(TEMP1*TEMP2*U');
else
    n=m; B=I;
end

end
    