function acf = mapacf (D0, D1, maxk)

mf = size (D0,1);

M = inv(-D0)*D1;
M = M - eye(mf);
M = [ones(mf,1) M(:,2:mf)];
pif = [1 zeros(1,mf-1)] * inv(M);

acf = zeros(maxk,1);
m1f = inv(-D0) * ones(mf,1);
m2f = 2 * inv(-D0)^2 * ones(mf,1);
etf = pif * m1f;
et2f = pif * m2f;
cv2f = (et2f - etf^2) / etf^2;
alphaf = pif * inv(-D0) / (cv2f * etf * pif * inv(-D0) * ones(mf,1));
betaf = m1f;
for k=1:maxk
    acf(k) = alphaf * (inv(-D0) * D1)^k * betaf - 1/cv2f;
end