function [beta,B] = APHRepresentation (alpha, A)

if ~CheckME(alpha, A)
	r=0;
    beta = 0;
    B=0;
	return;
end

lambda = -eig(A);

if max(abs(imag(lambda)))>0
	disp('Complex eigenvalue!')
    r=0;
    beta = 0;
    B=0;
	return;
end


lambda2 = sort(lambda);
maxelem = max(lambda2);
lambda3=lambda2(lambda2~=maxelem);
mx = diag(-lambda2)+diag(lambda3, 1);
simmx=SimularityMatrix(A, mx);
beta=alpha*simmx;
B=mx;

end
