function r = CheckME (alpha, A)

global BuToolsVerbose;
prec = 10^-14;

if length(alpha)~=size(A,1)
    if BuToolsVerbose
        fprintf ('CheckME: alpha and A have different sizes!');
    end
    r = 0;
    return;
end

if size(A,1)~=size(A,2)
    if BuToolsVerbose
        fprintf ('CheckME: A is not a square matrix!');
    end
    r = 0;
    return;
end

if max(real(eig(A)))>=0
    if BuToolsVerbose
        fprintf ('CheckME: There is an eigenvalue of the matrix with not negative real part!');
    end
    r = 0;
    return;
end

bignum = 10^10;
e=eig(A);
reig=eig(A);
reig(imag(reig)~=0)=-bignum;

ceig=eig(A);
ceig(imag(ceig)==0)=-bignum;
ceig=real(ceig);

if max(reig)<max(ceig)
    if BuToolsVerbose
        fprintf ('CheckME: The dominant eigenvalue of the matrix is not real!');
    end
    r = 0;
    return;
end

if max(reig)==max(ceig)
    if BuToolsVerbose
        fprintf ('CheckME: The dominant and a complex eigenvalue has the same real part!');
    end
    r = 0;
    return;
end


r = 1;