function [vectorout,matrixout] = METoPH (alpha, T) 

if ~CheckME(alpha, T)
	r=0;
    vectorout = 0;
    matrixout = 0;
	return;
end

s = size(T,1);

h = ones(1, s);

-(h*T)';

-(h*T)'*alpha;

S=[T, -(h*T)'*alpha];

[d0, d1] = RAPToMAP(T, -(h*T)'*alpha);

[maxNum, maxIndex] = max(d1(:));

[row, col] = ind2sub(size(d1), maxIndex);

vectorout=d1(row,:)/sum(d1(row,:).*h);

matrixout = d0;