function positiveflag = PositiveRep (alpha, A)

sizeA=size(alpha,2);

h=ones(sizeA,1);

shift=0;

if -alpha*A*h<0
    if BuToolsVerbose
        fprintf ('Negative density at 0!');
    end
    positiveflag=0;
    return;
end

if -alpha*A*h==0 &&-alpha*A*A*h<0
    if BuToolsVerbose
        fprintf ('0 density at 0 and negative derivative!');
    end
    positiveflag=0;
    return;
end

Ldominant=real(eig(-A));

Ldominant=max(Ldominant);

L=Ldominant/2;

niter=0;
iter=0;

for i=1:1:18;
         niter=niter+iter;
         iter=0;
         L=2*L;
         vec=alpha;
         AL=(eye(sizeA)+A/L);
         out=vec*(h-AL*h);
         
         while min(vec)<0
             iter=iter+1;
             vec=vec*AL;
             out=vec*(h-AL*h);
             %vec,out,L,i,iter
             if out<0
                 iter=iter-1;
                 break
             end
         end
         
         if min(vec)>0 
             niter=niter+iter;
             vec, out, L, i, iter, niter
             positiveflag=1;
             return;
         end
         
         if out < 0
             outold=0;
             poziter=iter;
             while out<outold
                 iter=iter+1;
                 outold=out;
                 vec=vec*AL;
                 out=vec*(h-AL*h);
                 %vec,out,L,i,iter
             end
         end

         
        if -alpha*expm(A*iter/L)*A*h < 0
            niter=niter+iter;
            disp('Negative density at ');
            disp(shift+iter/L);
            disp('f(x)=');
            disp(-alpha*expm(A*iter/L)*A*h);
            disp('!!!')
            disp('Lambda=')
            disp(L)
            disp('i=')
            disp(i)
            disp('iter=')
            disp(iter)
            disp('niter=')
            disp(niter)
            if (shift+iter/L)*Ldominant>20
                if BuToolsVerbose
                    fprintf ('Time*dominant=!');
                    (shift+iter/L)*Ldominant2
                     fprintf ('>20!!! It might be a numerical error!!!');
                end
            end
            positiveflag=0;
            return;
        end

deltashift=iter/L;
deltashift=poziter/L;
alpha=alpha*expm(A*deltashift);

disp('deltashift=')
disp(deltashift)
shift=shift+deltashift
disp('vec=')
disp(alpha)
     
end

disp('Could not decide the non-negativity till Lambda=')
L
i
iter
niter
positiveflag=0;
return;

