function [D0, D1] = mep2map (H0, H1)

% function e = error (x, kind)
%     if kind==0
%         e = exp(-100*mp(x));
%     elseif kind==1
%         e = exp(-1000*mp(x));
%     elseif kind==2
%         e = exp(-2*mp(x));
%     elseif kind==3
%         e = exp(-(mp(x)-1).^3);
%     end
% end
% 
% function dist = errorfun (h0u, h1u, kind)
%     eh1u = error (h1u, kind);
%     eh0u = error (h0u, kind);
%     dist = sum(sum(eh1u));
%     for i=1:size(h0u,1)
%         for j=1:size(h0u,2)
%             if i~=j
%                 dist = dist + eh0u(i,j);
%             end
%         end
%     end
% end

function dist = errorfun (h0u, h1u, kind)
    
    if kind==0
    
        w1 = min(min(h1u));
        w0 = min(min(h0u-diag(diag(h0u))));
        dist = min(w0,w1);
    else
        dist = 0;
        for i=1:size(h0u,1)
            for j=1:size(h0u,2)
                if h1u(i,j)<0
                    dist = dist - h1u(i,j);
                end
                if i~=j && h0u(i,j)<0
                    dist = dist - h0u(i,j);
                end
            end
        end
    end
%     
%     eh1u = error (h1u, kind);
%     eh0u = error (h0u, kind);
%     dist = sum(sum(eh1u));
%     for i=1:size(h0u,1)
%         for j=1:size(h0u,2)
%             if i~=j
%                 dist = dist + eh0u(i,j);
%             end
%         end
%     end
end

function [h0u, h1u] = transform (a0, a1, i, j, b)
    B = eye(size(a0));
    B(i,j) = b;
    B(i,i) = 1-b;
    h0u = inv(B) * a0 * B;
    h1u = inv(B) * a1 * B;
end

function [h0n, h1n, dist] = elementary (A0, A1, b, k)
    dist = errorfun (A0, A1, k);
    h0n = A0;
    h1n = A1;
    for i=1:size(A0,1)
        for j=1:size(A0,2)
            if i~=j
                [h0u, h1u] = transform (A0, A1, i, j, b);
                distu = errorfun (h0u, h1u, k);
                if distu<dist
                    h0n = h0u;
                    h1n = h1u;
                    dist = distu;
                end
                [h0u, h1u] = transform (A0, A1, i, j, -b);
                distu = errorfun (h0u, h1u, k);
                if distu<dist
                    h0n = h0u;
                    h1n = h1u;
                    dist = distu;
                end
            end
        end
    end
end

function [Ho0, Ho1] = minimize (mH0, mH1, iter, b, k)
    lastdist = errorfun (mH0, mH1, k);
    Ho0 = mH0;
    Ho1 = mH1;
    for i=1:iter
        [h0n, h1n, dist] = elementary (Ho0, Ho1, b, k);
        if dist >= lastdist
            break;
        else
            lastdist = dist;
        end
        Ho0 = h0n;
        Ho1 = h1n;
    end
end

function m = checkmap (A0, A1)
    m = 1;
    for i=1:size(A0,1)
        for j=1:size(A0,2)
            if A1(i,j)<0
                m = 0;
                return;
            end
            if i~=j && A0(i,j)<0
                m = 0;
                return;
            end
        end
    end
end

function mainiter
    m = 0;
    b = 0.5;
    for i=1:20
        for j=1:10
            for k=0:3
                [H0, H1] = minimize (H0, H1, 10, b, k);
                m = checkmap (H0, H1);
                if m
                    break;
                end
            end
            if m
                break;
            end
        end
        b = b / 2;
    end
end

mainiter;

D0 = H0;
D1 = H1;

end