function [n,B]=staircase(X,Z)
%Computes a smaller representation of RAP using staircase algorithm

epsilon=10^-8;
msize=size(X,3);
m=size(X,1);
U=eye(m);

%The sum of the ranks calculated in every loop
ranksum=0;

crit=1; %The stopping criteria

while crit
    r=rank(Z);
    ranksum=ranksum+r;
    [Ui,S,T] = svd(Z);
    %Computation of Z_1,X_i,Y_i
    TEMP=Ui'*Z;
    Z1=TEMP(1:r,:);
    mm=size(X,1);
    TEMP=zeros(mm, mm, msize);
       
   for ii=1:1:msize
      TEMP(:,:,ii)= Ui'*X(:,:,ii)*Ui;
      X1(:,:,ii)=TEMP(1:r,1:r,ii);
      X2(:,:,ii)=TEMP(1:r,r+1:end,ii);
      X3(:,:,ii)=TEMP(r+1:end,1:r,ii);
      X4(:,:,ii)=TEMP(r+1:end,r+1:end,ii);
   end
   
    sizeUi=size(Ui,1);
    %Calculation of the new U,X,Z matrices
    Transf=eye(ranksum-r+size(Ui,1));
    Transf(end-size(Ui,1)+1:end,end-size(Ui,1)+1:end)=Ui';
     
    U=(Transf*U')';
    mm=size(X4,1);
    X=zeros(mm, mm, msize);
    X(:,:,1)=X4(:,:,1);
    Z=X3(:,:,1);
    for ii=2:1:msize
        X(:,:,ii)=X4(:,:,ii);
        Z=horzcat(Z,X3(:,:,ii));
    end
    
   if norm(Z)<epsilon || rank(Z)==m-ranksum
        crit=0;
    end
end
n=ranksum;
I=eye(m,m);
if norm(Z)<epsilon 

    x=U'*ones(size(U,1),1);
    x=x(1:n);

    %does x have a 0 value somewhere
    yes=0;
    zeroloc=zeros(n,1);
    nonzero=0; %this will indicate a row of x for which x's value is non-zero
    for l=1:n
       if abs(x(l))<10^(-8)
           yes=1;
           zeroloc(l,1)=1;
       elseif nonzero==0
           nonzero=l;
       end
    end
    
    R=eye(n,n);
    if yes
        for l=1:n;
           if zeroloc(l,1)==1;
            R(l,nonzero)=1;
           end
        end
    end


     y=R*x;
     Gamma=diag(y);
     TEMP1=I;
     TEMP1(1:n,1:n)=inv(Gamma);

     TEMP2=I; 
     TEMP2(1:n,1:n)=R;
     B=inv(TEMP1*TEMP2*U');

elseif rank(Z)==m-ranksum
    B=I;
    n=m;
end
    