function r = CheckGenerator (Q)

global BuToolsVerbose;
prec = 10^-14;

if size(Q,1)~=size(Q,2)
    if BuToolsVerbose
        fprintf ('CheckGenerator: Generator is not a square matrix!');
    end
    r = 0;
    return;
end

if any(diag(Q)>=0)
    if BuToolsVerbose
        fprintf ('CheckGenerator: The diagonal of the generator is not negative!');
    end
    r = 0;
    return;
end

N = size(Q,1);
odQ = Q<0;
odQ(1:N+1:N^2) = 0;
if any(odQ)
    if BuToolsVerbose
        fprintf ('CheckGenerator: The generator has negative off-diagonal element!');
    end
    r = 0;
    return;
end

if any(abs(sum(Q,2))>prec)
    if BuToolsVerbose
        fprintf ('CheckGenerator: The rowsum of the generator is not 0 (precision: %g)!', prec);
    end
    r = 0;
    return;
end

r = 1;