function r = CheckMAP (D0, D1)

global BuToolsVerbose;
prec = 10^-14;

if ~CheckTransientGenerator(D0)
    r = 0;
    return;
end

if size(D0)~=size(D1)
    if BuToolsVerbose
        fprintf ('CheckMAP: D0 and D1 have different sizes!');
    end
    r = 0;
    return;
end

if min(min(D1))<0
    if BuToolsVerbose
        fprintf ('CheckMAP: D1 has negative element!');
    end
    r = 0;
    return;
end

if any(abs(sum(D0+D1,2))>prec)
    if BuToolsVerbose
        fprintf ('CheckMAP: The rowsum of D0+D1 is not 0 (precision: %g)!', prec);
    end
    r = 0;
    return;
end

r = 1;