function r = CheckProbMatrix (P)

global BuToolsVerbose;
prec = 10^-14;

if size(P,1)~=size(P,2)
    if BuToolsVerbose
        fprintf ('CheckProbMatrix: P is not a square matrix!');
    end
    r = 0;
    return;
end

if min(min(P))<0
    if BuToolsVerbose
        fprintf ('CheckProbMatrix: P has negative element!');
    end
    r = 0;
    return;
end

if any(abs(sum(P,2))-1)>prec
    if BuToolsVerbose
        fprintf ('CheckGenerator: The rowsum of P is not 1 (precision: %g)!', prec);
    end
    r = 0;
    return;
end

r = 1;