function r = CheckTransientGenerator (Q)

global BuToolsVerbose;
prec = 10^-14;

if size(Q,1)~=size(Q,2)
    if BuToolsVerbose
        fprintf ('CheckTransientGenerator: Generator is not a square matrix!');
    end
    r = 0;
    return;
end

if any(diag(Q)>=0)
    if BuToolsVerbose
        fprintf ('CheckTransientGenerator: The diagonal of the generator is not negative!');
    end
    r = 0;
    return;
end

N = size(Q,1);
odQ = Q<0;
odQ(1:N+1:N^2) = 0;
if any(odQ)
    if BuToolsVerbose
        fprintf ('CheckTransientGenerator: The generator has negative off-diagonal element!');
    end
    r = 0;
    return;
end

if max(sum(Q,2))>prec
    if BuToolsVerbose
        fprintf ('CheckTransientGenerator: The rowsum of the generator is greater than 0 (precision: %g)!', prec);
    end
    r = 0;
    return;
end

if max(real(eig(Q)))>=-prec
    if BuToolsVerbose
        fprintf ('CheckTransientGenerator: The generator has non-negative eigenvalue (precision: %g)!', prec);
    end
    r = 0;
    return;
end

r = 1;