function r = CheckTransientProbMatrix (P)

global BuToolsVerbose;
prec = 10^-14;

if size(P,1)~=size(P,2)
    if BuToolsVerbose
        fprintf ('CheckTransientProbMatrix: P is not a square matrix!');
    end
    r = 0;
    return;
end

if min(P)<prec
    if BuToolsVerbose
        fprintf ('CheckTransientProbMatrix: P has negative element!');
    end
    r = 0;
    return;
end

if any(sum(P,2)-1>prec)
    if BuToolsVerbose
        fprintf ('CheckTransientProbMatrix: The rowsum of P is not less or equal than 1 (precision: %g)!', prec);
    end
    r = 0;
    return;
end

if max(real(eig(P)))>=1-prec
    if BuToolsVerbose
        fprintf ('CheckTransientGenerator: The real part of the largest eigenvalue is not less than 1 (precision: %g)!', prec);
    end
    r = 0;
    return;
end

r = 1;