function [bestY, dist] = elementary (X, b, k, evalFunc, transSize, transFunc)
    dist = evalFunc (X, k);
    bestY = X;
    for i=1:transSize
        for j=1:transSize
            if i~=j
                % create elementary transformation matrix with +b
                B = eye(transSize);
                B(i,j) = b;
                B(i,i) = 1-b;
                % apply similarity transform
                Y = transFunc (X, B);
                distu = evalFunc (Y, k);
                % store result if better
                if distu < dist
                    bestY = Y;
                    dist = distu;
                end
                % create elementary transformation matrix with -b
                B = eye(transSize);
                B(i,j) = b;
                B(i,i) = 1-b;
                % apply similarity transform
                Y = transFunc (X, B);
                distu = evalFunc (Y, k);
                % store result if better
                if distu < dist
                    bestY = Y;
                    dist = distu;
                end
            end
        end
    end
end